/*
Copyright © 2021 NAME HERE <EMAIL ADDRESS>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package cmd

import (
	"github.com/spf13/cobra"
	"k8s.io/cli-runtime/pkg/genericclioptions"
	cmdutil "k8s.io/kubectl/pkg/cmd/util"
)

var kubeConfigFlags = genericclioptions.NewConfigFlags(false)

var rootCmd = &cobra.Command{
	Use:   "libre.sh",
	Short: "libre.sh - kubernetes the libre way",
	Long: `Libre.sh is a kubernetes distribution aimed at hosting freesoftware for the people. 
	Think of it as the debian of kubernetes distribution for hosted software, or as a distributed yunohost..`,
}

func Execute() {
	cobra.CheckErr(rootCmd.Execute())
}

func KubeFactory() cmdutil.Factory {
	matchVersionKubeConfigFlags := cmdutil.NewMatchVersionFlags(kubeConfigFlags)
	return cmdutil.NewFactory(matchVersionKubeConfigFlags)
}

func AddKubeFlags(cmd *cobra.Command) {
	kubeConfigFlags.AddFlags(cmd.Flags())
}

func CheckErr(err error) {
	if err != nil {
		panic(err)
	}
}
